' ********************************************************************************* 
Public Class tinner_form
    Dim tinner As tinlib.tinner_class
    Dim rand As Random = New Random()
    ' ********************************************************************************* 
    Public Sub New()' Constructor 
        InitializeComponent()
        print_triangles_button.Enabled = False
        maketin_button.Enabled = False
        tinner = New tinlib.tinner_class()
    End Sub ' tinner_form.New
    ' ********************************************************************************* 
    Private Sub create_random_points(ByVal num_points As Integer)
        ' First wipe out the old TIN points and triangles 
        tinner.clear()

        ' Always allocate the number of points you are going to need first. 
        ' This is just an array we are loading! 
        tinner.allocate_points(num_points)

        ' So of course the index (first parameter) must always be a 
        ' sequence from zero to your number of points-1 
        Dim last_point As Integer = num_points - 1 ' Zero-based index
        Dim cnt As Integer
        For cnt = 0 To last_point
            Dim randx As Double = rand.Next(0, plot_box.ClientRectangle.Width)
            Dim randy As Double = rand.Next(0, plot_box.ClientRectangle.Height)
            Dim randz As Double = rand.NextDouble()
            tinner.set_point(cnt, randx, randy, randz)
        Next
    End Sub ' create_random_points 
    ' ********************************************************************************* 
    Private Sub getpoints_button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles getpoints_button.Click
        print_triangles_button.Enabled = False
        maketin_button.Enabled = True
        create_random_points(100) ' create 100 xyz points 
        plot_box.Refresh()
    End Sub
    ' ********************************************************************************* 
    Private Sub maketin_button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles maketin_button.Click
        tinner.generate_tin(1000000.0) ' maximum line length 1000000.0
        plot_box.Refresh()
        print_triangles_button.Enabled = True
    End Sub
    ' ********************************************************************************* 
    Private Sub plot_box_Paint(ByVal sender As Object, ByVal e As PaintEventArgs) Handles plot_box.Paint
        Dim grx As Graphics = e.Graphics
        plot_points(grx)
        plot_triangles(grx)
    End Sub
    ' ********************************************************************************* 
    Private Sub plot_points(ByVal grx As Graphics)
        ' Plot all of our xyz points. 
        Dim wdt As Integer = 2
        Dim hgt As Integer = 2
        Dim halfwdt As Integer = wdt / 2
        Dim halfhgt As Integer = hgt / 2
        Dim br As Brush = Brushes.Blue
        Dim last_point As Integer = tinner.get_num_points() - 1 ' Zero-based index
        Dim point_cnt As Integer
        For point_cnt = 0 To last_point
            Dim x0 As Double = 0.0
            Dim y0 As Double = 0.0
            Dim z0 As Double = 0.0
            tinner.get_point(point_cnt, x0, y0, z0)
            grx.FillRectangle(br, CInt(x0 - halfwdt), CInt(y0 - halfhgt), CInt(wdt), CInt(hgt))
            ' grx.FillEllipse(br, CInt(x0 - halfwdt), CInt(y0 - halfhgt), CInt(wdt), CInt(hgt))
        Next
    End Sub ' plot_points 
    ' ********************************************************************************* 
    Private Sub plot_triangles(ByVal grx As Graphics)
        ' Plot all TIN triangles, if any have been created. 
        Dim vdex0 = 0, vdex1 = 0, vdex2 As UInteger = 0
        ' indexes of the points of the triangle corners
        Dim x0 = 0.0, y0 = 0.0, z0 = 0.0, x1 = 0.0, y1 = 0.0, z1 = 0.0, x2 = 0.0, y2 = 0.0, z2 As Double = 0.0
        Dim outstr As New System.Text.StringBuilder
        Console.WriteLine("tinner.num_triangles:{0}.", tinner.num_triangles)

        Dim pen As Pen = Pens.Red
        Dim last_triangle As Integer = tinner.num_triangles - 1 ' Zero-based index
        Dim tdex As Integer ' tcnt is the triangle index 
        For tdex = 0 To last_triangle
            ' v0,v1, and v2 return the indexes of each triangle corner, as found in the point array 
            If (tinner.get_triangle_indexes(tdex, vdex0, vdex1, vdex2) > 0) Then
                ' so now that we have the vertex indexes, look up the actual coordinates 
                tinner.get_point(vdex0, x0, y0, z0)
                tinner.get_point(vdex1, x1, y1, z1)
                tinner.get_point(vdex2, x2, y2, z2)
                ' draw the triangle itself 
                grx.DrawLine(pen, CInt(x0), CInt(y0), CInt(x1), CInt(y1))
                grx.DrawLine(pen, CInt(x1), CInt(y1), CInt(x2), CInt(y2))
                grx.DrawLine(pen, CInt(x2), CInt(y2), CInt(x0), CInt(y0))
            Else ' if it returned false, then we went out of range of the list of triangles. 
                System.Console.WriteLine("Error, no triangle at index:{0}.", tdex)
            End If
        Next
        System.Console.WriteLine(outstr.ToString())
    End Sub ' plot_triangles 
    ' ********************************************************************************* 
    Private Sub print_triangles_button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles print_triangles_button.Click
        Dim tf As New textform(print_triangles(tinner))
        tf.ShowDialog(Me)
    End Sub ' print_triangles_button_Click 
    ' ********************************************************************************* 
    Private Function print_triangles(ByVal tinner As tinlib.tinner_class) As String
        ' *******************************************************************
        ' *  Print out all the triangles created by tinning.
        ' * *****************************************************************
        Dim vdex0 = 0, vdex1 = 0, vdex2 As UInteger = 0 ' indexes of the points of the triangle corners
        Dim x0 = 0.0, y0 = 0.0, z0 = 0.0, x1 = 0.0, y1 = 0.0, z1 = 0.0, x2 = 0.0, y2 = 0.0, z2 As Double = 0.0
        Dim outstr As New System.Text.StringBuilder
        Console.WriteLine("tinner.num_triangles:{0}.", tinner.num_triangles)
        Dim last_triangle = tinner.num_triangles - 1 ' Zero-based index
        Dim tdex As UInteger ' tcnt is the triangle index 
        For tdex = 0 To last_triangle
            ' v0,v1, and v2 return the indexes of each triangle corner, as found in the point array
            If (tinner.get_triangle_indexes(tdex, vdex0, vdex1, vdex2) > 0) Then
                ' so now that we have the vertex indexes, look up the actual coordinates 
                tinner.get_point(vdex0, x0, y0, z0)
                tinner.get_point(vdex1, x1, y1, z1)
                tinner.get_point(vdex2, x2, y2, z2)
                ' now just put the results into the output string 
                outstr.Append(System.String.Format("triangle {0}: ", tdex))
                outstr.Append(System.String.Format("(x:{0} y:{1} z:{2}) ", x0, y0, z0))
                outstr.Append(System.String.Format("(x:{0} y:{1} z:{2}) ", x1, y1, z1))
                outstr.Append(System.String.Format("(x:{0} y:{1} z:{2}) ", x2, y2, z2))
                outstr.Append(Environment.NewLine)
            Else ' if it returned false, then we went out of range of the list of triangles. 
                System.Console.WriteLine("Error, no triangle at index:{0}.", tdex)
            End If
        Next
        Return outstr.ToString()
    End Function ' print_triangles 
    ' ********************************************************************************* 
    Public Class textform
        Inherits Form ' For quick display of triangles as text coordinates 
        Public tex As TextBox = New TextBox()
        Public Sub New(ByVal contents As String)
            Me.Width = 1000
            Me.Height = 1000
            tex = New TextBox()
            tex.Multiline = True
            tex.Dock = DockStyle.Fill
            Me.Controls.Add(tex)
            tex.Text = contents
            tex.Show()
        End Sub
    End Class
    ' ********************************************************************************* 
    Private Sub tinner_form_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        tinner.Dispose()
    End Sub
End Class
